"""
 * JPython Database Specification API 2.0
 *
 * $Id: test.py,v 1.3 2000/07/07 15:01:08 bzimmer Exp $
 *
 * Copyright (C) 2000 Brian Zimmer <bzimmer@ziclix.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *

 Tips:

 1) Make sure the jar com.ziclix.python.sql is in your CLASSPATH:
	on NT: set CLASSPATH=zxJDBC.jar;%CLASSPATH%
 2) Start JPython version 1.1 or higher (obtained from http://www.jpython.org)
 3) Connect using your JDBC url, for example:
	for MySql:
		url = "jdbc:mysql://localhost:3306/MySql"
		username = None
		password = None
		driver = "org.gjt.mm.mysql.Driver" (obtained from http://www.gjt.org/)
 4) Follow the example below for connecting, executing statements and performing queries.
"""

from com.ziclix.python.sql import zxJDBC

def test(url, user, pwd, driver):
	print
	print "connecting"
	db = zxJDBC.connect(url, user, pwd, driver)
	print
	print "connected"
	db.autocommit = 0
	c = db.cursor()
	try:
		c.execute("drop table z_test")
	except:
		pass
	c.execute("create table z_test ( id int, name varchar(20), state varchar(2) )")
	db.commit()
	print
	print "created the table"
	print
	print "table schema"
	c.columns(None, None, "z_test", None);
	db.commit()
	if c.rowcount > 0:
		for a in c.fetchall():
			print " " + str(a)

	print
	print "inserting records"
	c.execute("insert into z_test (id, name, state) values (1, 'test0', 'il')")
	c.execute("insert into z_test (id, name, state) values (2, 'test1', 'wi')")
	c.execute("insert into z_test (id, name, state) values (3, 'test2', 'tx')")
	c.execute("insert into z_test (id, name, state) values (4, 'test3', 'co')")
	c.execute("insert into z_test (id, name, state) values (5, 'test4', 'il')")
	c.execute("insert into z_test (id, name, state) values (6, 'test5', 'ca')")
	c.execute("insert into z_test (id, name, state) values (7, 'test6', 'wi')")
	db.commit()
	c.execute("update z_test set name = ? where id = ?", [("testing",5)], {0:zxJDBC.VARCHAR})
	db.commit()
	c.execute("insert into z_test (id, name, state) values (?, ?, ?)", [(8, 'test8', 'ak'), (9, 'test9', 'wi')])
	db.commit()
	print
	print "count the number of people living in each state"
	c.execute("select state, count(*) residents from z_test group by state order by residents")
	db.commit()
	if c.rowcount > 0:
		for a in c.fetchall():
			print " " + str(a)
	print
	print "what are the names of the people living in 'il' (uses a parameter)"
	c.execute("select name from z_test where state = ?", ["il"], {0:zxJDBC.VARCHAR})
	db.commit()
	if c.rowcount > 0:
		for a in c.fetchall():
			print " " + str(a)
	c.execute("drop table z_test")
	db.commit()
	print
	print "dropped the table"
	c.close()
	db.close()

if __name__ == '__main__':
	import sys
	test(sys.argv[1], sys.argv[2], sys.argv[3], sys.argv[4])
